diff --git a/tempesta_fw/filter.c b/tempesta_fw/filter.c
index 63733f052..ca6e78c6c 100644
--- a/tempesta_fw/filter.c
+++ b/tempesta_fw/filter.c
@@ -105,14 +105,17 @@ tfw_filter_check_ip(struct in6_addr *addr)
 	if (TDB_ITER_BAD(iter))
 		return TFW_PASS;
 
-	for (rule = (TfwFRule *)iter.rec->data;
-	     memcmp(&rule->addr, addr, sizeof(*addr)); )
-	{
+next:
+	rule = (TfwFRule *)iter.rec->data;
+	if (rule && memcmp(&rule->addr, addr, sizeof(*addr))) {
 		tdb_rec_next(ip_filter_db, &iter);
-		if (!(rule = (TfwFRule *)iter.rec->data))
-			return TFW_PASS;
+		goto next;
 	}
 
+	if (TDB_ITER_BAD(iter))
+		return TFW_PASS;
+
+	tdb_rec_put(iter.rec);
 	return rule->action == TFW_F_DROP ? TFW_BLOCK : TFW_PASS;
 }
 
